#!/bin/bash
set -euo pipefail

DIRNAME="$(dirname $0)"
echo "Unarchiving non-meson repos:"
DIRS=("pywigxjpf_ctypes" "pywigxjpf_ffi_dynamic" "pywigxjpf_ffi_static" "pywigxjpf_ffi_static_setuptools")
for DIR in "${DIRS[@]}"; do
    echo "Extracting $DIRNAME/$DIR.zip"
    unzip -q "$DIRNAME/$DIR.zip"
done

echo "Archiving meson repos:"
DIRS=("pywigxjpf_ffi_meson" "pywigxjpf_nanobind_meson")
for DIR in "${DIRS[@]}"; do
    echo "Unbundling $DIRNAME/$DIR.bundle"
    git clone -q "$DIRNAME/$DIR.bundle" "$DIR"
done
