Set-StrictMode -Version Latest
$ErrorActionPreference = 'Stop'

Push-Location subprojects/wigxjpf
meson setup --buildtype release build_release
meson compile -C build_release
Pop-Location

$libraryExtensions = @('dll', 'so', 'dylib', 'lib')
$copied = $false

foreach ($ext in $libraryExtensions) {
    $sourcePath = "subprojects/wigxjpf/build_release/*.$ext"
    $destPath = "."

    try {
        Copy-Item -Path $sourcePath -Destination $destPath -ErrorAction Stop
        $copied = $true
    }
    catch {
        continue
    }
}

if (-not $copied) {
    Write-Error "Could not copy library file"
}

python ffi_builder_dynamic.py
python pywigxjpf.py
