import sys

from cffi import FFI

ffibuilder = FFI()
ffibuilder_kwargs = dict(
    include_dirs=["subprojects/wigxjpf/inc/"],
    library_dirs=["./"],
    libraries=["wigxjpf_shared"],
    runtime_library_dirs=["./"],
)
if sys.platform.startswith("win"):
    del ffibuilder_kwargs["runtime_library_dirs"]
ffibuilder.set_source(
    "pywigxjpf_ffi",
    r"""
#include "wigxjpf.h"
    """,
    **ffibuilder_kwargs,
)
ffibuilder.cdef("""
    double wig3jj(int two_j1, int two_j2, int two_j3,
                  int two_m1, int two_m2, int two_m3);
    double wig6jj(int two_j1, int two_j2, int two_j3,
                  int two_m1, int two_m2, int two_m3);
    double wig9jj(int two_j1, int two_j2, int two_j3,
                  int two_j4, int two_j5, int two_j6,
                  int two_j7, int two_j8, int two_j9);
    void wig_table_init(int max_two_j, int wigner_type);
    void wig_table_free(void);
    void wig_temp_init(int max_two_j);
    void wig_temp_free(void);
""")

if __name__ == "__main__":
    ffibuilder.compile(verbose=True)
