from setuptools import build_meta as _orig
from setuptools.build_meta import *


def build_wigxjpf():
    """Build static and shared wigxjpf library. We only need the static library,
    so we don't copy anything, because CFFI will find it."""
    import subprocess as subp

    subp.check_call(
        "meson setup --buildtype release build_release",
        cwd="./subprojects/wigxjpf",
        shell=True,
    )
    subp.check_call(
        "meson compile -C build_release",
        cwd="./subprojects/wigxjpf",
        shell=True,
    )


def build_wheel(wheel_directory, config_settings=None, metadata_directory=None):
    build_wigxjpf()
    return _orig.build_wheel(
        wheel_directory, config_settings, metadata_directory
    )
