from contextlib import contextmanager

import pywigxjpf.pywigxjpf_ffi

table_init = pywigxjpf.pywigxjpf_ffi.lib.wig_table_init
table_free = pywigxjpf.pywigxjpf_ffi.lib.wig_table_free

temp_init = pywigxjpf.pywigxjpf_ffi.lib.wig_temp_init
temp_free = pywigxjpf.pywigxjpf_ffi.lib.wig_temp_free

wig3jj = pywigxjpf.pywigxjpf_ffi.lib.wig3jj
wig6jj = pywigxjpf.pywigxjpf_ffi.lib.wig6jj
wig9jj = pywigxjpf.pywigxjpf_ffi.lib.wig9jj


@contextmanager
def wigxjpf(max_two_j, wigner_type=9):
    table_init(max_two_j, wigner_type)
    temp_init(max_two_j)
    try:
        yield None
    finally:
        temp_free()
        table_free()


if __name__ == "__main__":
    with wigxjpf(100):
        val3j = wig3jj(2 * 10, 2 * 15, 2 * 10, 2 * (-3), 2 * 12, 2 * (-9))
        print("3J(10  15  10; -3  12  -9): %.12g" % val3j)

        val6j = wig6jj(2 * 10, 2 * 15, 2 * 10, 2 * 7, 2 * 7, 2 * 9)
        print("6J{10  15  10;  7   7   9}: %.12g" % val6j)

        val9j = wig9jj(1, 2, 3, 4, 6, 8, 3, 6, 9)
        print("9J{0.5 1 1.5; 2 3 4; 1.5 3 4.5}: %.12g" % val9j)
