#!/bin/bash
set -euo pipefail

rm -rf pywigxjpf*/.venv || true

echo "Test pywigxjpf_ctypes"
cd pywigxjpf_ctypes
python3 -m venv .venv
source .venv/bin/activate
python3 -m pip install meson ninja
./build.sh
deactivate
cd ..
read -p "Press Enter to continue"

echo "Test pywigxjpf_ffi_dynamic"
cd pywigxjpf_ffi_dynamic
python3 -m venv .venv
source .venv/bin/activate
python3 -m pip install meson ninja cffi setuptools
./build.sh
deactivate
cd ..
read -p "Press Enter to continue"

echo "Test pywigxjpf_ffi_static"
cd pywigxjpf_ffi_static
python3 -m venv .venv
source .venv/bin/activate
python3 -m pip install meson ninja cffi setuptools
./build.sh
deactivate
cd ..
read -p "Press Enter to continue"

echo "Test pywigxjpf_ffi_static_setuptools"
cd pywigxjpf_ffi_static_setuptools
python3 -m venv .venv
source .venv/bin/activate
python3 -m pip install .
python3 -m pywigxjpf.pywigxjpf
deactivate
cd ..
read -p "Press Enter to continue"

echo "Test pywigxjpf_ffi_meson"
cd pywigxjpf_ffi_meson
python3 -m venv .venv
source .venv/bin/activate
python3 -m pip install .
python3 -m pywigxjpf.pywigxjpf
deactivate
cd ..
read -p "Press Enter to continue"

echo "Test pywigxjpf_nanobind_meson"
cd pywigxjpf_nanobind_meson
python3 -m venv .venv
source .venv/bin/activate
python3 -m pip install .
python3 -m pywigxjpf.main
deactivate
cd ..
